blob: 75fe15c919d8120f0e81c0e2aef14b2ec4e27a63 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Brazdil2c27f2c2015-05-12 18:06:38 +010042checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070043export JAVA="java"
Alex Lightea1e7702016-07-11 13:39:55 -070044export JAVAC="javac -g -Xlint:-options"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010045export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070046export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070047export NEED_DEX="true"
Alan Leung0afa07a2017-10-03 16:56:30 -070048export USE_D8="false"
Colin Crosse0ef0a82017-07-27 21:29:18 +000049export USE_JACK="false"
Igor Murashkin2a337752017-06-16 14:34:40 +000050export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070051export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070052
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070053# If dx was not set by the environment variable, assume it is in the path.
54if [ -z "$DX" ]; then
55 export DX="dx"
56fi
57
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080058# If jasmin was not set by the environment variable, assume it is in the path.
59if [ -z "$JASMIN" ]; then
60 export JASMIN="jasmin"
61fi
62
Andreas Gampe8fda9f22014-10-03 16:15:37 -070063# If smali was not set by the environment variable, assume it is in the path.
64if [ -z "$SMALI" ]; then
65 export SMALI="smali"
66fi
67
68# If dexmerger was not set by the environment variable, assume it is in the path.
69if [ -z "$DXMERGER" ]; then
70 export DXMERGER="dexmerger"
71fi
72
Sebastien Hertz19ac0272015-02-24 17:39:50 +010073# If jack was not set by the environment variable, assume it is in the path.
74if [ -z "$JACK" ]; then
75 export JACK="jack"
76fi
77
Sebastien Hertz19ac0272015-02-24 17:39:50 +010078# ANDROID_BUILD_TOP is not set in a build environment.
79if [ -z "$ANDROID_BUILD_TOP" ]; then
80 export ANDROID_BUILD_TOP=$oldwd
81fi
82
Andreas Gampef47fb2f2016-06-24 22:30:29 -070083# ANDROID_HOST_OUT is not set in a build environment.
84if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsenf325e012017-03-03 12:35:30 -080085 export ANDROID_HOST_OUT=${OUT_DIR:-$ANDROID_BUILD_TOP/out}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070086fi
87
Sebastien Hertz19ac0272015-02-24 17:39:50 +010088# If JACK_CLASSPATH is not set, assume it only contains core-libart.
89if [ -z "$JACK_CLASSPATH" ]; then
Andreas Gampef47fb2f2016-06-24 22:30:29 -070090 export JACK_CLASSPATH="${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-libart-hostdex_intermediates/classes.jack:${ANDROID_HOST_OUT}/../common/obj/JAVA_LIBRARIES/core-oj-hostdex_intermediates/classes.jack"
Sebastien Hertz19ac0272015-02-24 17:39:50 +010091fi
92
Sebastien Hertz19ac0272015-02-24 17:39:50 +010093export JACK="$JACK -g -cp $JACK_CLASSPATH"
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080094
Igor Murashkine5181932017-06-15 16:03:50 -070095# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070096if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070097 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
98fi
99
Igor Murashkin271a0f82017-02-14 21:14:17 +0000100# Zipalign is not on the PATH in some configs, auto-detect it.
101if [ -z "$ZIPALIGN" ]; then
102 if which zipalign >/dev/null; then
103 ZIPALIGN="zipalign";
104 else
105 # TODO: Add a dependency for zipalign in Android.run-test.mk
106 # once it doesn't depend on libandroidfw (b/35246701)
107 case "$OSTYPE" in
108 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
109 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
110 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
111 esac
112 fi
113fi
114export ZIPALIGN
115
jeffhao5d1ac922011-09-29 17:41:15 -0700116info="info.txt"
117build="build"
118run="run"
119expected="expected.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700120check_cmd="check"
jeffhao5d1ac922011-09-29 17:41:15 -0700121output="output.txt"
122build_output="build-output.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100123cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700124strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700125lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700126testlib="arttestd"
jeffhao5d1ac922011-09-29 17:41:15 -0700127run_args="--quiet"
David Brazdil4846d132015-01-15 19:07:08 +0000128build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700129
Alex Light91de25f2015-10-28 17:00:06 -0700130quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000131debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700132prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700133target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700134dev_mode="no"
135update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700136debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000137relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800138runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700139usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700140build_only="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700141suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700142trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700143trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700144basic_verify="false"
145gc_verify="false"
146gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700147jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700148jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700149jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700150jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700151strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700152always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700153never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700154have_dex2oat="yes"
155have_patchoat="yes"
156have_image="yes"
Jeff Haodcdc85b2015-12-04 14:06:18 -0800157multi_image_suffix=""
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000158android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700159bisection_search="no"
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800160suspend_timeout="500000"
Alex Light10bc5a42016-05-10 10:01:22 -0700161# By default we will use optimizing.
162image_args=""
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000163image_suffix=""
jeffhao5d1ac922011-09-29 17:41:15 -0700164
165while true; do
166 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700167 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700168 DEX_LOCATION=$tmp_dir
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +0100169 run_args="${run_args} --host"
jeffhao5d1ac922011-09-29 17:41:15 -0700170 shift
Alex Light91de25f2015-10-28 17:00:06 -0700171 elif [ "x$1" = "x--quiet" ]; then
172 quiet="yes"
173 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700174 elif [ "x$1" = "x--use-java-home" ]; then
175 if [ -n "${JAVA_HOME}" ]; then
176 export JAVA="${JAVA_HOME}/bin/java"
177 export JAVAC="${JAVA_HOME}/bin/javac -g"
178 else
179 echo "Passed --use-java-home without JAVA_HOME variable set!"
180 usage="yes"
181 fi
182 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800183 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700184 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800185 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800186 runtime="jvm"
Alex Lightbc90d0f2016-05-09 16:21:09 -0700187 image_args=""
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700188 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700189 NEED_DEX="false"
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100190 USE_JACK="false"
Nicolas Geoffray288a4a22014-10-07 11:02:40 +0100191 run_args="${run_args} --jvm"
Alex Lighteb7c1442015-08-31 13:17:42 -0700192 build_args="${build_args} --jvm"
jeffhao5d1ac922011-09-29 17:41:15 -0700193 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800194 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700195 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700196 testlib="arttest"
Alex Lightfaf90b62016-08-12 14:43:48 -0700197 run_args="${run_args} -O"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700198 shift
199 elif [ "x$1" = "x--dalvik" ]; then
200 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800201 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700202 shift
Alex Light03a112d2014-08-25 13:25:56 -0700203 elif [ "x$1" = "x--no-dex2oat" ]; then
204 have_dex2oat="no"
205 shift
206 elif [ "x$1" = "x--no-patchoat" ]; then
207 have_patchoat="no"
208 shift
209 elif [ "x$1" = "x--no-image" ]; then
210 have_image="no"
211 shift
Jeff Haodcdc85b2015-12-04 14:06:18 -0800212 elif [ "x$1" = "x--multi-image" ]; then
213 multi_image_suffix="-multi"
214 shift
Andreas Gampec23c9c92014-10-28 14:47:25 -0700215 elif [ "x$1" = "x--pic-test" ]; then
216 run_args="${run_args} --pic-test"
217 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700218 elif [ "x$1" = "x--relocate" ]; then
219 relocate="yes"
220 shift
221 elif [ "x$1" = "x--no-relocate" ]; then
222 relocate="no"
223 shift
224 elif [ "x$1" = "x--prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100225 run_args="${run_args} --prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700226 prebuild_mode="yes"
227 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800228 elif [ "x$1" = "x--compact-dex-level" ]; then
229 option="$1"
230 shift
231 run_args="${run_args} $option $1"
232 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700233 elif [ "x$1" = "x--strip-dex" ]; then
234 run_args="${run_args} --strip-dex"
235 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000236 elif [ "x$1" = "x--debuggable" ]; then
237 run_args="${run_args} -Xcompiler-option --debuggable"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000238 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000239 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700240 elif [ "x$1" = "x--no-prebuild" ]; then
Nicolas Geoffray5fd18ba2014-10-03 12:08:38 +0100241 run_args="${run_args} --no-prebuild"
Alex Lighta59dd802014-07-02 16:28:08 -0700242 prebuild_mode="no"
243 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700244 elif [ "x$1" = "x--gcverify" ]; then
245 basic_verify="true"
246 gc_verify="true"
247 shift
248 elif [ "x$1" = "x--gcstress" ]; then
249 basic_verify="true"
250 gc_stress="true"
251 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700252 elif [ "x$1" = "x--jvmti-step-stress" ]; then
253 jvmti_step_stress="true"
254 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700255 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
256 jvmti_redefine_stress="true"
257 shift
Alex Light43e935d2017-06-19 15:40:40 -0700258 elif [ "x$1" = "x--jvmti-field-stress" ]; then
259 jvmti_field_stress="true"
260 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700261 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
262 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700263 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800264 elif [ "x$1" = "x--suspend-timeout" ]; then
265 shift
266 suspend_timeout="$1"
267 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700268 elif [ "x$1" = "x--image" ]; then
269 shift
270 image="$1"
271 run_args="${run_args} --image $image"
Elliott Hughes7c046102011-10-19 18:16:03 -0700272 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000273 elif [ "x$1" = "x-Xcompiler-option" ]; then
274 shift
275 option="$1"
276 run_args="${run_args} -Xcompiler-option $option"
277 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000278 elif [ "x$1" = "x--build-option" ]; then
279 shift
280 option="$1"
281 build_args="${build_args} $option"
282 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700283 elif [ "x$1" = "x--runtime-option" ]; then
284 shift
285 option="$1"
286 run_args="${run_args} --runtime-option $option"
287 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700288 elif [ "x$1" = "x--gdb-arg" ]; then
289 shift
290 gdb_arg="$1"
291 run_args="${run_args} --gdb-arg $gdb_arg"
292 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700293 elif [ "x$1" = "x--debug" ]; then
294 run_args="${run_args} --debug"
295 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700296 elif [ "x$1" = "x--debug-wrap-agent" ]; then
297 run_args="${run_args} --debug-wrap-agent"
298 shift
Alex Light0e151e72017-10-25 10:50:35 -0700299 elif [ "x$1" = "x--with-agent" ]; then
300 shift
301 option="$1"
302 run_args="${run_args} --with-agent $1"
303 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700304 elif [ "x$1" = "x--debug-agent" ]; then
305 shift
306 option="$1"
307 run_args="${run_args} --debug-agent $1"
308 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700309 elif [ "x$1" = "x--gdb" ]; then
310 run_args="${run_args} --gdb"
311 dev_mode="yes"
312 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700313 elif [ "x$1" = "x--strace" ]; then
314 strace="yes"
Mathieu Chartier2576be22016-05-24 10:24:53 -0700315 run_args="${run_args} --timeout 1800 --invoke-with strace --invoke-with -o --invoke-with $tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700316 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700317 elif [ "x$1" = "x--zygote" ]; then
318 run_args="${run_args} --zygote"
319 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800320 elif [ "x$1" = "x--interpreter" ]; then
Nicolas Geoffray4650c932016-05-10 09:13:13 +0000321 run_args="${run_args} --interpreter"
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700322 image_suffix="-interpreter"
323 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800324 elif [ "x$1" = "x--jit" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700325 image_args="--jit"
Nicolas Geoffrayb76bc782016-09-14 12:33:34 +0000326 image_suffix="-interpreter"
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800327 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700328 elif [ "x$1" = "x--optimizing" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700329 image_args="-Xcompiler-option --compiler-backend=Optimizing"
jeffhao0dff3f42012-11-20 15:13:43 -0800330 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700331 elif [ "x$1" = "x--no-verify" ]; then
Richard Uhlerf4b34872016-04-13 11:03:46 -0700332 run_args="${run_args} --no-verify"
jeffhao5d1ac922011-09-29 17:41:15 -0700333 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700334 elif [ "x$1" = "x--verify-soft-fail" ]; then
Alex Light10bc5a42016-05-10 10:01:22 -0700335 image_args="--verify-soft-fail"
Andreas Gampe825570c2015-07-26 10:26:03 -0700336 image_suffix="-interp-ac"
Igor Murashkin7617abd2015-07-10 18:27:47 -0700337 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700338 elif [ "x$1" = "x--no-optimize" ]; then
339 run_args="${run_args} --no-optimize"
340 shift
341 elif [ "x$1" = "x--no-precise" ]; then
342 run_args="${run_args} --no-precise"
343 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700344 elif [ "x$1" = "x--invoke-with" ]; then
345 shift
346 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700347 if [ "x$what" = "x" ]; then
348 echo "$0 missing argument to --invoke-with" 1>&2
349 usage="yes"
350 break
351 fi
Ian Rogers0e033672013-04-19 10:22:46 -0700352 run_args="${run_args} --invoke-with ${what}"
jeffhao5d1ac922011-09-29 17:41:15 -0700353 shift
354 elif [ "x$1" = "x--dev" ]; then
355 run_args="${run_args} --dev"
356 dev_mode="yes"
357 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700358 elif [ "x$1" = "x--build-only" ]; then
359 build_only="yes"
360 shift
Alan Leung0afa07a2017-10-03 16:56:30 -0700361 elif [ "x$1" = "x--build-with-d8" ]; then
362 USE_D8="true"
363 shift
Sebastien Hertz19ac0272015-02-24 17:39:50 +0100364 elif [ "x$1" = "x--build-with-javac-dx" ]; then
365 USE_JACK="false"
366 shift
367 elif [ "x$1" = "x--build-with-jack" ]; then
368 USE_JACK="true"
369 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700370 elif [ "x$1" = "x--output-path" ]; then
371 shift
372 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700373 if [ "x$tmp_dir" = "x" ]; then
374 echo "$0 missing argument to --output-path" 1>&2
375 usage="yes"
376 break
377 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700378 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000379 elif [ "x$1" = "x--android-root" ]; then
380 shift
381 if [ "x$1" = "x" ]; then
382 echo "$0 missing argument to --android-root" 1>&2
383 usage="yes"
384 break
385 fi
386 android_root="$1"
387 run_args="${run_args} --android-root $1"
388 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700389 elif [ "x$1" = "x--update" ]; then
390 update_mode="yes"
391 shift
392 elif [ "x$1" = "x--help" ]; then
393 usage="yes"
394 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700395 elif [ "x$1" = "x--64" ]; then
396 run_args="${run_args} --64"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700397 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700398 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200399 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700400 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200401 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700402 elif [ "x$1" = "x--stream" ]; then
403 trace_stream="true"
404 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700405 elif [ "x$1" = "x--always-clean" ]; then
406 always_clean="yes"
407 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700408 elif [ "x$1" = "x--never-clean" ]; then
409 never_clean="yes"
410 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800411 elif [ "x$1" = "x--dex2oat-swap" ]; then
412 run_args="${run_args} --dex2oat-swap"
413 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700414 elif [ "x$1" = "x--instruction-set-features" ]; then
415 shift
416 run_args="${run_args} --instruction-set-features $1"
417 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700418 elif [ "x$1" = "x--bisection-search" ]; then
419 bisection_search="yes"
420 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000421 elif [ "x$1" = "x--vdex" ]; then
422 run_args="${run_args} --vdex"
423 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000424 elif [ "x$1" = "x--vdex-filter" ]; then
425 shift
426 filter=$1
427 run_args="${run_args} --vdex-filter $filter"
428 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700429 elif [ "x$1" = "x--random-profile" ]; then
430 run_args="${run_args} --random-profile"
431 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700432 elif [ "x$1" = "x--dex2oat-jobs" ]; then
433 shift
434 run_args="${run_args} -Xcompiler-option -j$1"
435 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700436 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700437 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700438 usage="yes"
439 break
440 else
441 break
442 fi
443done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700444
Alex Light10bc5a42016-05-10 10:01:22 -0700445run_args="${run_args} ${image_args}"
Alex Light91de25f2015-10-28 17:00:06 -0700446# Allocate file descriptor real_stderr and redirect it to the shell's error
447# output (fd 2).
448if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
449 exec {real_stderr}>&2
450else
451 # In bash before version 4.1 we need to do a manual search for free file
452 # descriptors.
453 FD=3
454 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
455 real_stderr=$FD
456 eval "exec ${real_stderr}>&2"
457fi
458if [ "$quiet" = "yes" ]; then
459 # Force the default standard output and error to go to /dev/null so we will
460 # not print them.
461 exec 1>/dev/null
462 exec 2>/dev/null
463fi
464
465function err_echo() {
466 echo "$@" 1>&${real_stderr}
467}
468
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700469# tmp_dir may be relative, resolve.
470#
471# Cannot use realpath, as it does not exist on Mac.
472# Cannot us a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700473# Cannot use readlink -m, as it does not exist on Mac.
474# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700475noncanonical_tmp_dir=$tmp_dir
Brian Carlstromc580e042014-09-08 21:37:39 -0700476tmp_dir="`cd $oldwd ; python -c "import os; print os.path.realpath('$tmp_dir')"`"
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700477mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700478
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800479# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000480if [ ! "$runtime" = "jvm" ]; then
481 run_args="${run_args} --runtime-option -XX:ThreadSuspendTimeout=$suspend_timeout"
482fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800483
Alex Lighte7873ec2014-08-12 09:53:50 -0700484if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800485 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
486 run_args="${run_args} --runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0"
Alex Lighte7873ec2014-08-12 09:53:50 -0700487fi
488if [ "$gc_verify" = "true" ]; then
489 run_args="${run_args} --runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc"
490fi
491if [ "$gc_stress" = "true" ]; then
Mathieu Chartierd9eb2842016-08-12 16:11:24 -0700492 run_args="${run_args} --gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m"
Alex Lighte7873ec2014-08-12 09:53:50 -0700493fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700494if [ "$jvmti_redefine_stress" = "true" ]; then
495 run_args="${run_args} --no-app-image --jvmti-redefine-stress"
496fi
Alex Lightc38c3692017-06-27 15:45:14 -0700497if [ "$jvmti_step_stress" = "true" ]; then
498 run_args="${run_args} --no-app-image --jvmti-step-stress"
499fi
Alex Light43e935d2017-06-19 15:40:40 -0700500if [ "$jvmti_field_stress" = "true" ]; then
501 run_args="${run_args} --no-app-image --jvmti-field-stress"
502fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700503if [ "$jvmti_trace_stress" = "true" ]; then
504 run_args="${run_args} --no-app-image --jvmti-trace-stress"
Alex Light8f2c6d42017-04-10 16:27:35 -0700505fi
Jeff Hao85139a32014-07-23 11:52:52 -0700506if [ "$trace" = "true" ]; then
Andreas Gampe7526d782015-06-22 22:53:45 -0700507 run_args="${run_args} --runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000"
508 if [ "$trace_stream" = "true" ]; then
509 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
510 # the ability to analyze the file and just write to /dev/null.
511 run_args="${run_args} --runtime-option -Xmethod-trace-file:/dev/null"
512 # Enable streaming mode.
513 run_args="${run_args} --runtime-option -Xmethod-trace-stream"
514 else
515 run_args="${run_args} --runtime-option -Xmethod-trace-file:${DEX_LOCATION}/trace.bin"
516 fi
517elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700518 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700519 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700520fi
521
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700522# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000523# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100524function guess_target_arch_name() {
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000525 grep32bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm|x86|mips)$'`
526 grep64bit=`ls ${ANDROID_PRODUCT_OUT}/data/art-test | grep -E '^(arm64|x86_64|mips64)$'`
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700527 if [ "x${suffix64}" = "x64" ]; then
528 target_arch_name=${grep64bit}
529 else
530 target_arch_name=${grep32bit}
531 fi
532}
533
David Brazdil853a4c32015-09-28 16:15:50 +0100534function guess_host_arch_name() {
535 if [ "x${suffix64}" = "x64" ]; then
536 host_arch_name="x86_64"
537 else
538 host_arch_name="x86"
539 fi
540}
541
Alex Lighta59dd802014-07-02 16:28:08 -0700542if [ "$target_mode" = "no" ]; then
543 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700544 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700545 err_echo "--prebuild with --jvm is unsupported"
Alex Lighta59dd802014-07-02 16:28:08 -0700546 exit 1;
547 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700548 fi
549fi
550
Alex Light03a112d2014-08-25 13:25:56 -0700551if [ "$have_patchoat" = "no" ]; then
552 run_args="${run_args} --no-patchoat"
553fi
554
555if [ "$have_dex2oat" = "no" ]; then
556 run_args="${run_args} --no-dex2oat"
557fi
558
Jeff Hao201803f2013-11-20 18:11:39 -0800559if [ ! "$runtime" = "jvm" ]; then
560 run_args="${run_args} --lib $lib"
561fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700562
Jeff Hao201803f2013-11-20 18:11:39 -0800563if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700564 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000565 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Andreas Gampe50be66f2015-12-28 14:31:06 -0800566 bpath="${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Richard Uhler76f5cb62016-04-04 13:30:16 -0700567 run_args="${run_args} --boot --runtime-option -Xbootclasspath:${bpath}"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700568 else
569 true # defaults to using target BOOTCLASSPATH
570 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800571elif [ "$runtime" = "art" ]; then
572 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100573 guess_host_arch_name
Richard Uhlerbb00f812017-02-16 14:21:10 +0000574 run_args="${run_args} --boot ${ANDROID_HOST_OUT}/framework/core${image_suffix}${multi_image_suffix}.art"
Colin Crossafd3c9e2016-09-16 13:47:21 -0700575 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib${suffix64}:${ANDROID_HOST_OUT}/nativetest${suffix64}"
Jeff Hao201803f2013-11-20 18:11:39 -0800576 else
David Brazdil853a4c32015-09-28 16:15:50 +0100577 guess_target_arch_name
Dimitry Ivanov49c2c922017-02-14 11:06:14 -0800578 run_args="${run_args} --runtime-option -Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}"
Richard Uhlerbb00f812017-02-16 14:21:10 +0000579 run_args="${run_args} --boot /data/art-test/core${image_suffix}${multi_image_suffix}.art"
Jeff Hao201803f2013-11-20 18:11:39 -0800580 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700581 if [ "$relocate" = "yes" ]; then
582 run_args="${run_args} --relocate"
583 else
584 run_args="${run_args} --no-relocate"
585 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700586elif [ "$runtime" = "jvm" ]; then
587 # TODO: Detect whether the host is 32-bit or 64-bit.
Alex Lightfba89fe2017-01-12 16:11:02 -0800588 run_args="${run_args} --runtime-option -Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700589fi
590
Alex Light03a112d2014-08-25 13:25:56 -0700591if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700592 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700593 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700594 exit 1
595 fi
Alex Light03a112d2014-08-25 13:25:56 -0700596 run_args="${run_args} --no-image"
597fi
598
jeffhao5d1ac922011-09-29 17:41:15 -0700599if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700600 err_echo "--dev and --update are mutually exclusive"
601 usage="yes"
602fi
603
604if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
605 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700606 usage="yes"
607fi
608
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700609if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
610 err_echo "--bisection-search and --prebuild are mutually exclusive"
611 usage="yes"
612fi
613
614if [ "$bisection_search" = "yes" -a "$have_dex2oat" = "no" ]; then
615 err_echo "--bisection-search and --no-dex2oat are mutually exclusive"
616 usage="yes"
617fi
618
619if [ "$bisection_search" = "yes" -a "$have_patchoat" = "no" ]; then
620 err_echo "--bisection-search and --no-patchoat are mutually exclusive"
621 usage="yes"
622fi
623
jeffhao5d1ac922011-09-29 17:41:15 -0700624if [ "$usage" = "no" ]; then
625 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
626 test_dir=`basename "$oldwd"`
627 else
628 test_dir="$1"
629 fi
630
631 if [ '!' -d "$test_dir" ]; then
632 td2=`echo ${test_dir}-*`
633 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700634 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700635 usage="yes"
636 fi
637 test_dir="$td2"
638 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700639 # Shift to get rid of the test name argument. The rest of the arguments
640 # will get passed to the test run.
641 shift
642fi
643
Søren Gjesse620d0a52016-09-19 11:12:51 +0200644# For building with javac and dx always use Java 7. The dx compiler
645# only support byte codes from Java 7 or earlier (class file major
646# version 51 or lower).
647if [ "$USE_JACK" != "true" ] && [ "$NEED_DEX" = "true" ]; then
648 export JAVAC="${JAVAC} -source 1.7 -target 1.7"
649fi
650
jeffhao5d1ac922011-09-29 17:41:15 -0700651if [ "$usage" = "yes" ]; then
652 prog=`basename $prog`
653 (
654 echo "usage:"
655 echo " $prog --help Print this message."
656 echo " $prog [options] [test-name] Run test normally."
657 echo " $prog --dev [options] [test-name] Development mode" \
658 "(dumps to stdout)."
659 echo " $prog --update [options] [test-name] Update mode" \
660 "(replaces expected.txt)."
661 echo ' Omitting the test name or specifying "-" will use the' \
662 "current directory."
663 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000664 echo " -O Run non-debug rather than debug build (off by default)."
665 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000666 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000667 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800668 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700669 echo " --debug Wait for the default debugger to attach."
670 echo " --debug-agent <agent-path>"
671 echo " Wait for the given debugger agent to attach. Currently"
672 echo " only supported on host."
673 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
674 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700675 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000676 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000677 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lightfadfee92015-10-28 09:40:10 -0700678 echo " --gdb-arg Pass an option to gdb."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000679 echo " --build-only Build test files only (off by default)."
Alan Leung0afa07a2017-10-03 16:56:30 -0700680 echo " --build-with-d8 Build test files with javac and d8 (off by default)."
Søren Gjesse620d0a52016-09-19 11:12:51 +0200681 echo " --build-with-javac-dx Build test files with javac and dx (off by default)."
682 echo " --build-with-jack Build test files with jack and jill (on by default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000683 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800684 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000685 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000686 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700687 echo " --verify-soft-fail Force soft fail verification (off by default)."
688 echo " Verification is enabled if neither --no-verify"
689 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000690 echo " --no-optimize Turn off optimization (on by default)."
691 echo " --no-precise Turn off precise GC (on by default)."
692 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700693 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000694 echo " other runtime options are ignored."
695 echo " --no-dex2oat Run as though dex2oat was failing."
696 echo " --no-patchoat Run as though patchoat was failing."
697 echo " --prebuild Run dex2oat on the files before starting test. (default)"
698 echo " --no-prebuild Do not run dex2oat on the files before starting"
699 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700700 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000701 echo " --relocate Force the use of relocating in the test, making"
702 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000703 echo " address before running."
704 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700705 echo " --image Run the test using a precompiled boot image. (default)"
706 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000707 echo " --host Use the host-mode virtual machine."
708 echo " --invoke-with Pass --invoke-with option to runtime."
709 echo " --dalvik Use Dalvik (off by default)."
710 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700711 echo " --use-java-home Use the JAVA_HOME environment variable"
712 echo " to find the java compiler and runtime"
713 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000714 echo " --output-path [path] Location where to store the build" \
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700715 "files."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000716 echo " --64 Run the test in 64-bit mode"
717 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700718 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700719 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000720 echo " --gcstress Run with gc stress testing"
721 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700722 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700723 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700724 echo " --jvmti-redefine-stress"
725 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000726 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700727 echo " --never-clean Keep the test files even if the test succeeds."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000728 echo " --android-root [path] The path on target for the android root. (/system by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000729 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700730 echo " --instruction-set-features [string]"
731 echo " Set instruction-set-features for compilation."
Jeff Haodcdc85b2015-12-04 14:06:18 -0800732 echo " --multi-image Use a set of images compiled with dex2oat multi-image for"
733 echo " the boot class path."
Alex Lightfadfee92015-10-28 09:40:10 -0700734 echo " --pic-test Compile the test code position independent."
Alex Light91de25f2015-10-28 17:00:06 -0700735 echo " --quiet Don't print anything except failure messages"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700736 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000737 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800738 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700739 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700740 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700741 exit 1
742fi
743
744cd "$test_dir"
745test_dir=`pwd`
746
747td_info="${test_dir}/${info}"
748td_expected="${test_dir}/${expected}"
749
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700750if [ ! -r $td_info ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700751 err_echo "${test_dir}: missing file $td_info"
Brian Carlstrom22469aa2012-09-07 10:34:57 -0700752 exit 1
753fi
754
755if [ ! -r $td_expected ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700756 err_echo "${test_dir}: missing file $td_expected"
jeffhao5d1ac922011-09-29 17:41:15 -0700757 exit 1
758fi
759
760# copy the test to a temp dir and run it
761
Elliott Hughes510c8782011-10-06 10:57:34 -0700762echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700763
764rm -rf "$tmp_dir"
765cp -Rp "$test_dir" "$tmp_dir"
766cd "$tmp_dir"
767
768if [ '!' -r "$build" ]; then
769 cp "${progdir}/etc/default-build" build
Zheng Xuc6667102015-05-15 16:08:45 +0800770else
771 cp "${progdir}/etc/default-build" .
jeffhao5d1ac922011-09-29 17:41:15 -0700772fi
773
774if [ '!' -r "$run" ]; then
775 cp "${progdir}/etc/default-run" run
Zheng Xuc6667102015-05-15 16:08:45 +0800776else
777 cp "${progdir}/etc/default-run" .
jeffhao5d1ac922011-09-29 17:41:15 -0700778fi
779
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700780if [ '!' -r "$check_cmd" ]; then
781 cp "${progdir}/etc/default-check" check
Zheng Xuc6667102015-05-15 16:08:45 +0800782else
783 cp "${progdir}/etc/default-check" .
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700784fi
785
jeffhao5d1ac922011-09-29 17:41:15 -0700786chmod 755 "$build"
787chmod 755 "$run"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700788chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700789
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700790export TEST_NAME=`basename ${test_dir}`
791
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000792# Tests named '<number>-checker-*' will also have their CFGs verified with
793# Checker when compiled with Optimizing on host.
794if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]]; then
795 if [ "$runtime" = "art" -a "$image_suffix" = "" ]; then
796 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
797 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
798 run_checker="yes"
799
800 if [ "$target_mode" = "no" ]; then
801 cfg_output_dir="$tmp_dir"
802 checker_args="--arch=${host_arch_name^^}"
803 else
804 cfg_output_dir="$DEX_LOCATION"
805 checker_args="--arch=${target_arch_name^^}"
806 fi
807
808 if [ "$debuggable" = "yes" ]; then
809 checker_args="$checker_args --debuggable"
810 fi
811
812 run_args="${run_args} -Xcompiler-option --dump-cfg=$cfg_output_dir/$cfg_output \
813 -Xcompiler-option -j1"
814 fi
815 fi
816fi
817
Mathieu Chartier031768a2015-08-27 10:25:02 -0700818 run_args="${run_args} --testlib ${testlib}"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700819
Richard Uhler020c0f32017-03-14 16:23:17 +0000820# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
821# ART output to approximately 128MB. This should be more than sufficient
822# for any test while still catching cases of runaway output.
823# Set a hard limit to encourage ART developers to increase the ulimit here if
824# needed to support a test case rather than resetting the limit in the run
825# script for the particular test in question.
Orion Hodsonbd328d32017-03-24 11:24:10 +0000826if ! ulimit -f 128000; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000827 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700828fi
829
Igor Murashkin2a337752017-06-16 14:34:40 +0000830if [[ "$target_mode" == "yes" ]]; then
831 build_args="$build_args --target"
832else
833 build_args="$build_args --host"
834fi
835
836if [[ "$dev_mode" == "yes" ]]; then
837 build_args="$build_args --dev"
838fi
839
jeffhao5d1ac922011-09-29 17:41:15 -0700840good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000841good_build="yes"
842good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -0700843export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -0700844if [ "$dev_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000845 "./${build}" $build_args 2>&1
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700846 build_exit="$?"
847 echo "build exit status: $build_exit" 1>&2
848 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800849 echo "${test_dir}: running..." 1>&2
850 "./${run}" $run_args "$@" 2>&1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700851 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +0000852
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800853 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +0000854 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100855 if [ "$target_mode" = "yes" ]; then
856 adb pull $cfg_output_dir/$cfg_output &> /dev/null
857 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100858 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +0000859 checker_exit="$?"
860 if [ "$checker_exit" = "0" ]; then
861 good="yes"
862 fi
Alex Light91de25f2015-10-28 17:00:06 -0700863 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +0000864 else
865 good="yes"
866 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -0800867 fi
Calin Juravle3cf48772015-01-26 16:47:33 +0000868 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -0700869 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700870elif [ "$update_mode" = "yes" ]; then
David Brazdil4846d132015-01-15 19:07:08 +0000871 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700872 build_exit="$?"
873 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800874 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700875 "./${run}" $run_args "$@" >"$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000876 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100877 if [ "$target_mode" = "yes" ]; then
878 adb pull $cfg_output_dir/$cfg_output &> /dev/null
879 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100880 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000881 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700882 sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}"
883 good="yes"
884 else
Alex Light91de25f2015-10-28 17:00:06 -0700885 cat "$build_output" 1>&${real_stderr} 1>&2
886 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -0700887 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700888elif [ "$build_only" = "yes" ]; then
889 good="yes"
David Brazdil4846d132015-01-15 19:07:08 +0000890 "./${build}" $build_args >"$build_output" 2>&1
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700891 build_exit="$?"
892 if [ "$build_exit" '!=' '0' ]; then
893 cp "$build_output" "$output"
894 echo "build exit status: $build_exit" >>"$output"
895 diff --strip-trailing-cr -q "$expected" "$output" >/dev/null
896 if [ "$?" '!=' "0" ]; then
897 good="no"
Alex Light91de25f2015-10-28 17:00:06 -0700898 err_echo "BUILD FAILED For ${TEST_NAME}"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700899 fi
900 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -0700901 # Clean up extraneous files that are not used by tests.
Tsu Chiang Chuang0160d992013-09-13 14:17:42 -0700902 find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700903 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -0700904else
David Brazdil4846d132015-01-15 19:07:08 +0000905 "./${build}" $build_args >"$build_output" 2>&1
jeffhao5d1ac922011-09-29 17:41:15 -0700906 build_exit="$?"
907 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -0800908 echo "${test_dir}: running..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700909 "./${run}" $run_args "$@" >"$output" 2>&1
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000910 run_exit="$?"
911 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700912 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000913 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +0000914 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +0100915 if [ "$target_mode" = "yes" ]; then
916 adb pull $cfg_output_dir/$cfg_output &> /dev/null
917 fi
David Brazdil5cc343d2015-10-08 11:35:32 +0100918 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >> "$output" 2>&1
David Brazdil4846d132015-01-15 19:07:08 +0000919 checker_exit="$?"
920 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700921 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +0000922 good_run="no"
923 else
924 good_run="yes"
925 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000926 else
927 good_run="yes"
928 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700929 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000930 good_build="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700931 cp "$build_output" "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700932 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" >> "$output"
933 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$output"
Ian Rogersd9ad27d2014-10-27 13:48:21 -0700934 echo "Args: ${args}" >> "$output"
Andreas Gampef6930a82014-10-21 09:33:08 -0700935 echo "build exit status: $build_exit" >> "$output"
Andreas Gampe5c114902014-10-27 17:03:58 -0700936 max_name_length=$(getconf NAME_MAX ${tmp_dir})
937 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$output"
938 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Andreas Gampe602fbcd2014-10-27 17:06:29 -0700939 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700940 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700941 ./$check_cmd "$expected" "$output"
jeffhao5d1ac922011-09-29 17:41:15 -0700942 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +0000943 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
944 # output == expected
945 good="yes"
946 echo "${test_dir}: succeeded!" 1>&2
947 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700948 fi
949fi
950
jeffhao5d1ac922011-09-29 17:41:15 -0700951(
Alex Lightbfac14a2014-07-30 09:41:21 -0700952 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -0700953 echo "${test_dir}: FAILED!"
954 echo ' '
955 echo '#################### info'
956 cat "${td_info}" | sed 's/^/# /g'
957 echo '#################### diffs'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700958 diff --strip-trailing-cr -u "$expected" "$output" | tail -n 3000
jeffhao5d1ac922011-09-29 17:41:15 -0700959 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700960 if [ "$strace" = "yes" ]; then
961 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -0700962 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700963 echo '####################'
964 fi
Andreas Gampee79ca192017-07-31 10:30:16 -0700965 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
966 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
967 # tools used by the given ABI work for both x86 and x86-64.
968 echo "ABI: 'x86_64'" | cat - "$output" | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
969 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700970 echo ' '
971 fi
Alex Lightbfac14a2014-07-30 09:41:21 -0700972
Alex Light91de25f2015-10-28 17:00:06 -0700973) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -0700974
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700975# Attempt bisection only if the test failed.
976if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
977 # Bisecting works by skipping different optimization passes which breaks checker assertions.
978 if [ "$run_checker" == "yes" ]; then
979 echo "${test_dir}: not bisecting, checker test." 1>&2
980 else
981 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700982 echo "${test_dir}: bisecting..." 1>&2
983 cwd=`pwd`
984 maybe_device_mode=""
985 raw_cmd=""
986 if [ "$target_mode" = "yes" ]; then
987 # Produce cmdline.sh in $DEX_LOCATION. "$@" is passed as a runtime option
988 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
989 # to exec in order to preserve pid when calling dalvikvm. This is required
990 # for bisection search to correctly retrieve logs from device.
991 "./${run}" $run_args --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
992 adb shell chmod u+x "$DEX_LOCATION/cmdline.sh"
993 maybe_device_mode="--device"
994 raw_cmd="$DEX_LOCATION/cmdline.sh"
995 else
996 raw_cmd="$cwd/${run} --external-log-tags $run_args $@"
997 fi
998 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
999 $maybe_device_mode \
1000 --raw-cmd="$raw_cmd" \
1001 --check-script="$cwd/check" \
1002 --expected-output="$cwd/expected.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001003 --logfile="$cwd/bisection_log.txt" \
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001004 --timeout=300
1005 fi
1006fi
1007
Alex Lightbfac14a2014-07-30 09:41:21 -07001008# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001009if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001010 cd "$oldwd"
1011 rm -rf "$tmp_dir"
1012 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
1013 adb shell rm -rf $DEX_LOCATION
1014 fi
1015 if [ "$good" = "yes" ]; then
1016 exit 0
1017 fi
1018fi
1019
1020
1021(
1022 if [ "$always_clean" = "yes" ]; then
1023 echo "${TEST_NAME} files deleted from host "
1024 if [ "$target_mode" == "yes" ]; then
1025 echo "and from target"
1026 fi
1027 else
1028 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1029 if [ "$target_mode" == "yes" ]; then
1030 echo "and in ${DEX_LOCATION} on target"
1031 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001032 fi
1033
Alex Light91de25f2015-10-28 17:00:06 -07001034) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001035
Alex Light6a870fa2016-05-31 16:36:19 -07001036if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1037 exit 0
1038else
1039 exit 1
1040fi